import javax.naming.*;
import javax.naming.directory.*;
import java.util.Hashtable;

/**
  * Demonstrates how to get an attribute definition's schema from the corresponding
  * attribute.
  *
  * usage: java GetAttributeDefn
  */
class GetAttributeDefn {
    public static void main(String[] args) {

	// Set up environment for creating initial context
	Hashtable env = new Hashtable(11);
	env.put(Context.INITIAL_CONTEXT_FACTORY, 
	    "com.sun.jndi.ldap.LdapCtxFactory");
	env.put(Context.PROVIDER_URL, "ldap://localhost:389/o=JNDITutorial");

	try {
	    // Create the initial context
	    DirContext ctx = new InitialDirContext(env);

	    // Get an attribute of that type
	    Attributes attrs = ctx.getAttributes("cn=Ted Geisel, ou=People",
		new String[]{"cn"});
	    Attribute cnAttr = attrs.get("cn");

	    // Get its attribute definition
	    DirContext cnSchema = cnAttr.getAttributeDefinition();

	    // Get cnSchema's attributes
	    Attributes cnAttrs = cnSchema.getAttributes("");

	    System.out.println(cnAttrs);
	} catch (NamingException e) {
	    e.printStackTrace();
	}
    }
}
